//-------------------------------------------------------------------------------------
//
// Copyright 2009 Intel Corporation
// All Rights Reserved
//
// Permission is granted to use, copy, distribute and prepare derivative works of this
// software for any purpose and without fee, provided, that the above copyright notice
// and this statement appear in all copies.  Intel makes no representations about the
// suitability of this software for any purpose.  THIS SOFTWARE IS PROVIDED "AS IS."
// INTEL SPECIFICALLY DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED, AND ALL LIABILITY,
// INCLUDING CONSEQUENTIAL AND OTHER INDIRECT DAMAGES, FOR THE USE OF THIS SOFTWARE,
// INCLUDING LIABILITY FOR INFRINGEMENT OF ANY PROPRIETARY RIGHTS, AND INCLUDING THE
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  Intel does not
// assume any responsibility for any errors which may appear in this software nor any
// responsibility to update it.
//

#include "StdAfx.h"
#include "Gfx.h"
#include "RenderTarget.h"

//________________________________________________________________________________
bool CGfx::SelectRenderTarget(CRenderTarget* pRT)
{
	HRESULT						hr;
	CComPtr<IDirect3DSurface9>	spSurface;
	
	if (pRT && pRT->m_spRenderTarget) 
		 spSurface = pRT->m_spRenderTarget;
	else m_spDevice->GetRenderTarget(0, &spSurface);
	
	hr = m_spDevice->SetRenderTarget(0, spSurface);
	IF_FAILED_RETURN(hr);
	
	return true;
}